"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
function useOpenTextInputProps(setQuizAnswers, nextQuestion, currentQuestionData, answerInputs) {
    const [input, setInput] = (0, react_1.useState)('');
    const onChangeHandler = (0, react_1.useCallback)((e) => {
        setInput(e.target.value);
    }, []);
    const onKeyDownHandler = (0, react_1.useCallback)((e) => {
        const { key } = e;
        if (key === 'Enter') {
            if (input && (currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.type) === 'open') {
                nextQuestion();
            }
        }
    }, [currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.type, input, nextQuestion]);
    (0, react_1.useEffect)(() => {
        if ((currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.type) === 'open') {
            setQuizAnswers(input);
        }
    }, [input, currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.type, currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.id, setQuizAnswers]);
    // Reset input for new open text questions
    (0, react_1.useEffect)(() => {
        var _a;
        if (answerInputs && (currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.id)) {
            const questionAnswer = (_a = answerInputs[currentQuestionData.id]) === null || _a === void 0 ? void 0 : _a.value;
            if (questionAnswer) {
                setInput(questionAnswer);
            }
            else {
                setInput('');
            }
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.id]);
    const getOpenTextInputProps = (0, react_1.useCallback)(() => ({
        className: 'cio-question-input-text',
        placeholder: (currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.input_placeholder) || 'Answer here...',
        value: input,
        onChange: onChangeHandler,
        onKeyDown: onKeyDownHandler,
    }), 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.input_placeholder, currentQuestionData === null || currentQuestionData === void 0 ? void 0 : currentQuestionData.id, input, onKeyDownHandler]);
    return getOpenTextInputProps;
}
exports.default = useOpenTextInputProps;
