"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const services_1 = require("../../services");
const utils_1 = require("../../utils");
const useQuizAddToFavorites = (cioClient, quizApiState, onAddToFavoritesClick) => {
    const quizAddToFavoritesHandler = (0, react_1.useCallback)((e, result, price, sendEvent = true) => {
        e.preventDefault();
        if (quizApiState.quizResults) {
            // Tracking call
            if (sendEvent) {
                (0, services_1.trackQuizConversion)(cioClient, quizApiState.quizResults, result, price, 'add_to_wishlist');
            }
            // User custom callback function
            if ((0, utils_1.isFunction)(onAddToFavoritesClick)) {
                onAddToFavoritesClick(result);
            }
        }
    }, [quizApiState, cioClient, onAddToFavoritesClick]);
    return quizAddToFavoritesHandler;
};
exports.default = useQuizAddToFavorites;
