"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const useQuizApiState_1 = tslib_1.__importDefault(require("./useQuizApiState"));
const useQuizLocalState_1 = tslib_1.__importDefault(require("./useQuizLocalState"));
const useSessionStorageState_1 = tslib_1.__importDefault(require("./useSessionStorageState"));
const useQuizState = (quizOptions, cioClient) => {
    const { sessionStateOptions, enableHydration } = quizOptions;
    // Quiz Local state
    const { quizLocalState, dispatchLocalState } = (0, useQuizLocalState_1.default)();
    // Quiz Session Storage state
    const { skipToResults, quizSessionStorageStateKey, hasSessionStorageState } = (0, useSessionStorageState_1.default)(quizLocalState, sessionStateOptions, enableHydration === undefined ? true : enableHydration);
    // Quiz API state
    const { quizApiState, dispatchApiState } = (0, useQuizApiState_1.default)(quizOptions, cioClient, quizLocalState, skipToResults, dispatchLocalState);
    return {
        quizApiState,
        quizLocalState,
        dispatchApiState,
        dispatchLocalState,
        quizSessionStorageState: {
            skipToResults,
            key: quizSessionStorageStateKey,
            hasSessionStorageState,
        },
    };
};
exports.default = useQuizState;
