import React, { useContext } from 'react';
import RedoButton from '../RedoButton/RedoButton';
import ShareButton from '../ShareButton/ShareButton';
import QuizContext from '../CioQuiz/context';
import ResultFilters from '../ResultFilters/ResultFilters';
import ZeroResults from '../ZeroResults/ZeroResults';
import Results from '../Results/Results';
import Spinner from '../Spinner/Spinner';
export default function ResultContainer(props) {
    const { resultCardOptions, onShare, resultsPageOptions } = props;
    const { state } = useContext(QuizContext);
    if (resultCardOptions) {
        const { resultCardSalePriceKey, resultCardRegularPriceKey, resultCardRatingCountKey, resultCardRatingScoreKey, renderResultCardPriceDetails, } = resultCardOptions;
        const numberOfResults = state?.quiz.results?.response?.results?.length;
        const zeroResults = !numberOfResults;
        const resultsTitle = zeroResults ? '' : 'Here are your results';
        if (state?.quiz.results) {
            return (React.createElement("div", { className: 'cio-results-container' },
                React.createElement("h1", { className: 'cio-results-title' }, resultsTitle),
                React.createElement("div", { className: 'cio-results-filter-and-redo-container cio-results-button-group' },
                    React.createElement(ResultFilters, { hasNoResults: zeroResults }),
                    React.createElement("div", { className: 'cio-results-redo-and-share-button-group' },
                        React.createElement(RedoButton, null),
                        resultsPageOptions?.showShareResultsButton && React.createElement(ShareButton, { onClick: onShare }))),
                !zeroResults && (React.createElement(React.Fragment, null,
                    React.createElement("div", { className: 'cio-results-num-results' },
                        numberOfResults,
                        " ",
                        numberOfResults === 1 ? 'result' : 'results'),
                    React.createElement(Results, { resultCardSalePriceKey: resultCardSalePriceKey, resultCardRegularPriceKey: resultCardRegularPriceKey, resultCardRatingCountKey: resultCardRatingCountKey, resultCardRatingScoreKey: resultCardRatingScoreKey, renderResultCardPriceDetails: renderResultCardPriceDetails }))),
                zeroResults && React.createElement(ZeroResults, null)));
        }
        return (React.createElement("div", { className: 'cio-results-container' },
            React.createElement(Spinner, null)));
    }
    return null;
}
