import { useCallback } from 'react';
import { trackQuizConversion } from '../../services';
import { isFunction } from '../../utils';
const useQuizAddToFavorites = (cioClient, quizApiState, onAddToFavoritesClick) => {
    const quizAddToFavoritesHandler = useCallback((e, result, price, sendEvent = true) => {
        e.preventDefault();
        if (quizApiState.quizResults) {
            // Tracking call
            if (sendEvent) {
                trackQuizConversion(cioClient, quizApiState.quizResults, result, price, 'add_to_wishlist');
            }
            // User custom callback function
            if (isFunction(onAddToFavoritesClick)) {
                onAddToFavoritesClick(result);
            }
        }
    }, [quizApiState, cioClient, onAddToFavoritesClick]);
    return quizAddToFavoritesHandler;
};
export default useQuizAddToFavorites;
